package com.steerinfo.baseinfo.meterbaseuserprintconfig.controller;

import com.steerinfo.baseinfo.meterbaseuserprintconfig.model.MeterBaseUserPrintConfig;
import com.steerinfo.baseinfo.meterbaseuserprintconfig.service.IMeterBaseUserPrintConfigService;
import com.steerinfo.baseinfo.meterbaseuserspotconfig.model.MeterBaseUserSpotConfig;
import com.steerinfo.baseinfo.meterbasevehiclerangeconfig.model.MeterBaseVehicleRangeConfig;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseUserPrintConfig RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-01-14 04:13
 * 类描述
 * 修订历史：
 * 日期：2023-01-14
 * 作者：generator
 * 参考：
 * 描述：MeterBaseUserPrintConfig RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseuserprintconfigs")
public class MeterBaseUserPrintConfigController extends BaseRESTfulController {

    @Autowired
    IMeterBaseUserPrintConfigService meterBaseUserPrintConfigService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserprintconfig:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserPrintConfig> list = meterBaseUserPrintConfigService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserprintconfig:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserPrintConfig> list = meterBaseUserPrintConfigService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseUserPrintConfig对象创建")
    @ApiImplicitParam(name = "meterBaseUserPrintConfig", value = "详细实体meterBaseUserPrintConfig", required = true, dataType = "MeterBaseUserPrintConfig")
    //@RequiresPermissions("meterbaseuserprintconfig:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseUserPrintConfig model){
        MeterBaseUserPrintConfig meterBaseUserPrintConfig = meterBaseUserPrintConfigService.add(model);
        return success(meterBaseUserPrintConfig);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserprintconfig:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseUserPrintConfig meterBaseUserPrintConfig = meterBaseUserPrintConfigService.getById(id);
        return success(meterBaseUserPrintConfig);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseUserPrintConfig信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseUserPrintConfig", value = "详细实体meterBaseUserPrintConfig", required = true, dataType = "MeterBaseUserPrintConfig")
    })
    //@RequiresPermissions("meterbaseuserprintconfig:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseUserPrintConfig model){
        model.setId(id);
        MeterBaseUserPrintConfig meterBaseUserPrintConfig = meterBaseUserPrintConfigService.modify(model);
        return success(meterBaseUserPrintConfig);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserprintconfig:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseUserPrintConfigService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据用户ID、物料编号、发货单位、收货单位获取列表", notes="不分页模糊查询")
    @PostMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestParam HashMap parmas){
        List<MeterBaseUserPrintConfig> list = meterBaseUserPrintConfigService.noPage(parmas);
        return success(list);
    }

    @ApiOperation(value="根据用户ID、物料编号、发货单位、收货单位获取列表", notes="分页模糊查询")
    @PostMapping(value = "/likeByDesc")
    public RESTfulResult likeByDesc(@RequestBody HashMap parmas){
        PageList<MeterBaseUserPrintConfig> list = meterBaseUserPrintConfigService.likeByDesc(parmas);
        return success(list);
    }

    @ApiOperation(value="根据用户、物料、发货单位、收货单位创建对象", notes="根据sso.sys_user表物料、发货单位、收货单位的id创建MeterBaseUserPrintConfig对象")
    @PostMapping(value = "/addModel")
    public RESTfulResult addModel(@RequestBody MeterBaseUserPrintConfig model){
        MeterBaseUserPrintConfig meterBaseUserPrintConfig  = meterBaseUserPrintConfigService.addModel(model);
        return success(meterBaseUserPrintConfig);
    }

    @ApiOperation(value="修改数据配置", notes="修改数据配置")
    @PostMapping(value = "/updateModel")
    public RESTfulResult updateModel(@RequestBody MeterBaseUserPrintConfig model){
        MeterBaseUserPrintConfig meterBaseUserPrintConfig = meterBaseUserPrintConfigService.updateModel(model);
        return success(meterBaseUserPrintConfig);
    }
}
